<?php

/*
 +--------------------------------------------------------------------+
 | CiviCRM version 1.8                                                |
 +--------------------------------------------------------------------+
 | Copyright CiviCRM LLC (c) 2004-2007                                |
 +--------------------------------------------------------------------+
 | This file is a part of CiviCRM.                                    |
 |                                                                    |
 | CiviCRM is free software; you can copy, modify, and distribute it  |
 | under the terms of the Affero General Public License Version 1,    |
 | March 2002.                                                        |
 |                                                                    |
 | CiviCRM is distributed in the hope that it will be useful, but     |
 | WITHOUT ANY WARRANTY; without even the implied warranty of         |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
 | See the Affero General Public License for more details.            |
 |                                                                    |
 | You should have received a copy of the Affero General Public       |
 | License along with this program; if not, contact CiviCRM LLC       |
 | at info[AT]civicrm[DOT]org.  If you have questions about the       |
 | Affero General Public License or the licensing  of CiviCRM,        |
 | see the CiviCRM license FAQ at http://civicrm.org/licensing        |
 +--------------------------------------------------------------------+
*/

/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */

/**
 * class to represent the actions that can be performed on a group of contacts
 * used by the search forms
 *
 */
define( 'CRM_CONTRIBUTE_TASK_DELETE_CONTRIBUTIONS',1);
define( 'CRM_CONTRIBUTE_TASK_PRINT_CONTRIBUTIONS',2);
define( 'CRM_CONTRIBUTE_TASK_EXPORT_CONTRIBUTIONS',3);
define( 'CRM_CONTRIBUTE_TASK_BATCH_CONTRIBUTIONS',4);
define( 'CRM_CONTRIBUTE_TASK_EMAIL_CONTACTS',5);
$GLOBALS['_CRM_CONTRIBUTE_TASK']['_tasks'] =  null;
$GLOBALS['_CRM_CONTRIBUTE_TASK']['_optionalTasks'] =  null;

class CRM_Contribute_Task {
    
           
            
           
            
                 

    /**
     * the task array
     *
     * @var array
     * @static
     */
    

    /**
     * the optional task array
     *
     * @var array
     * @static
     */
    

    /**
     * These tasks are the core set of tasks that the user can perform
     * on a contact / group of contacts
     *
     * @return array the set of tasks for a group of contacts
     * @static
     * @access public
     */
     function &tasks()
    {
        if (!($GLOBALS['_CRM_CONTRIBUTE_TASK']['_tasks'])) {
            $GLOBALS['_CRM_CONTRIBUTE_TASK']['_tasks'] = array(
                                  3 => ts( 'Export Contributions'   ),
                                  1 => ts( 'Delete Contributions'   ),
                                  5 => ts( 'Send Email to Contacts' ),
                                  4 => ts( 'Batch Update Contributions Via Profile' )
                                  );
        }
        asort($GLOBALS['_CRM_CONTRIBUTE_TASK']['_tasks']);
        return $GLOBALS['_CRM_CONTRIBUTE_TASK']['_tasks'];
    }

}

?>