<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_tableName'] =  'civicrm_currency';
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_CURRENCY']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_Currency extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Currency Id
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Currency Name
     *
     * @var string
     */
    var $name;
    /**
     * Currency Symbol
     *
     * @var string
     */
    var $symbol;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_currency
     */
    function CRM_Core_DAO_Currency() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_CURRENCY']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'name' => array(
                    'name' => 'name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Currency') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                    'import' => true,
                    'where' => 'civicrm_currency.name',
                    'headerPattern' => '',
                    'dataPattern' => '',
                    'export' => true,
                ) ,
                'symbol' => array(
                    'name' => 'symbol',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Symbol') ,
                    'maxlength' => 8,
                    'size' => CRM_UTILS_TYPE_EIGHT,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import'] = array();
            $fields = &CRM_Core_DAO_Currency::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import']['currency'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export'] = array();
            $fields = &CRM_Core_DAO_Currency::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export']['currency'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_CURRENCY']['_export'];
    }
}
?>