<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_tableName'] =  'civicrm_payment_processor_type';
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_PaymentProcessorType extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Payment Processor Type ID
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which Domain owns this payment processor.
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * Payment Processor Name.
     *
     * @var string
     */
    var $name;
    /**
     * Payment Processor Name.
     *
     * @var string
     */
    var $title;
    /**
     * Payment Processor Description.
     *
     * @var string
     */
    var $description;
    /**
     * Is this processor active?
     *
     * @var boolean
     */
    var $is_active;
    /**
     * Is this processor the default?
     *
     * @var boolean
     */
    var $is_default;
    /**
     *
     * @var string
     */
    var $user_name_label;
    /**
     *
     * @var string
     */
    var $password_label;
    /**
     *
     * @var string
     */
    var $signature_label;
    /**
     *
     * @var string
     */
    var $subject_label;
    /**
     *
     * @var string
     */
    var $class_name;
    /**
     *
     * @var string
     */
    var $url_site_default;
    /**
     *
     * @var string
     */
    var $url_recur_default;
    /**
     *
     * @var string
     */
    var $url_button_default;
    /**
     *
     * @var string
     */
    var $url_site_test_default;
    /**
     *
     * @var string
     */
    var $url_recur_test_default;
    /**
     *
     * @var string
     */
    var $url_button_test_default;
    /**
     * Billing Mode
     *
     * @var int unsigned
     */
    var $billing_mode;
    /**
     * Can process recurring contributions
     *
     * @var boolean
     */
    var $is_recur;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_payment_processor_type
     */
    function CRM_Core_DAO_PaymentProcessorType() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'name' => array(
                    'name' => 'name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Payment Processor variable name to be used in code') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'title' => array(
                    'name' => 'title',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Payment Processor Title') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'description' => array(
                    'name' => 'description',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Description') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'is_default' => array(
                    'name' => 'is_default',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'user_name_label' => array(
                    'name' => 'user_name_label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label for User Name if used') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'password_label' => array(
                    'name' => 'password_label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label for password') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'signature_label' => array(
                    'name' => 'signature_label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label for Signature') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'subject_label' => array(
                    'name' => 'subject_label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label for Subject') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'class_name' => array(
                    'name' => 'class_name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Suffix for PHP clas name implementation') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_site_default' => array(
                    'name' => 'url_site_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Live Site URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_recur_default' => array(
                    'name' => 'url_recur_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Live Recurring Payments URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_button_default' => array(
                    'name' => 'url_button_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Live Button URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_site_test_default' => array(
                    'name' => 'url_site_test_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Test Site URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_recur_test_default' => array(
                    'name' => 'url_recur_test_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Test Recurring Payment URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'url_button_test_default' => array(
                    'name' => 'url_button_test_default',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Default Test Button URL') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'billing_mode' => array(
                    'name' => 'billing_mode',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Billing Mode') ,
                    'required' => true,
                ) ,
                'is_recur' => array(
                    'name' => 'is_recur',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import'] = array();
            $fields = &CRM_Core_DAO_PaymentProcessorType::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import']['payment_processor_type'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export'] = array();
            $fields = &CRM_Core_DAO_PaymentProcessorType::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export']['payment_processor_type'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PAYMENTPROCESSORTYPE']['_export'];
    }
}
?>