<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_tableName'] =  'civicrm_preferences';
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_Preferences extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which Domain owns this contact
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * FK to Contact ID
     *
     * @var int unsigned
     */
    var $contact_id;
    /**
     * Is this the record for the domain setting?
     *
     * @var boolean
     */
    var $is_domain;
    /**
     * Number of locations to be displayed on edit page?
     *
     * @var int unsigned
     */
    var $location_count;
    /**
     * What tabs are displayed in the contact summary
     *
     * @var string
     */
    var $contact_view_options;
    /**
     * What tabs are displayed in the contact edit
     *
     * @var string
     */
    var $contact_edit_options;
    /**
     * What tabs are displayed in the advanced search screen
     *
     * @var string
     */
    var $advanced_search_options;
    /**
     * What tabs are displayed in the contact edit
     *
     * @var string
     */
    var $user_dashboard_options;
    /**
     * What fields are displayed from the address table
     *
     * @var string
     */
    var $address_options;
    /**
     * Format to display the address
     *
     * @var text
     */
    var $address_format;
    /**
     * Format to display a mailing label
     *
     * @var text
     */
    var $mailing_format;
    /**
     * Format to display a individual name
     *
     * @var text
     */
    var $individual_name_format;
    /**
     * object name of provider for address standarization
     *
     * @var string
     */
    var $address_standardization_provider;
    /**
     * user id for provider login
     *
     * @var string
     */
    var $address_standardization_userid;
    /**
     * url of address standardization service
     *
     * @var string
     */
    var $address_standardization_url;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_preferences
     */
    function CRM_Core_DAO_Preferences() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
                'contact_id' => 'civicrm_contact:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'contact_id' => array(
                    'name' => 'contact_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                ) ,
                'is_domain' => array(
                    'name' => 'is_domain',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'location_count' => array(
                    'name' => 'location_count',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Location Count') ,
                ) ,
                'contact_view_options' => array(
                    'name' => 'contact_view_options',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Contact View Options') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'contact_edit_options' => array(
                    'name' => 'contact_edit_options',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Contact Edit Options') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'advanced_search_options' => array(
                    'name' => 'advanced_search_options',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Advanced Search Options') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'user_dashboard_options' => array(
                    'name' => 'user_dashboard_options',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('User Dashboard Options') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'address_options' => array(
                    'name' => 'address_options',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Address Options') ,
                    'maxlength' => 128,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'address_format' => array(
                    'name' => 'address_format',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Address Format') ,
                ) ,
                'mailing_format' => array(
                    'name' => 'mailing_format',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Mailing Format') ,
                ) ,
                'individual_name_format' => array(
                    'name' => 'individual_name_format',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Individual Name Format') ,
                ) ,
                'address_standardization_provider' => array(
                    'name' => 'address_standardization_provider',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Address Standardization Provider') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'address_standardization_userid' => array(
                    'name' => 'address_standardization_userid',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Address Standardization Userid') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'address_standardization_url' => array(
                    'name' => 'address_standardization_url',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Address Standardization Url') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import'] = array();
            $fields = &CRM_Core_DAO_Preferences::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import']['preferences'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export'] = array();
            $fields = &CRM_Core_DAO_Preferences::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export']['preferences'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PREFERENCES']['_export'];
    }
}
?>